Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"")

cam = CreateCamera()
PositionEntity cam,0,10,-20

plane = CreatePlane()
EntityColor plane,64,128,128

light = CreateLight()

Global TableMesh = LoadMesh("PressPapier.b3d")

TableMesh2 = CopyMesh(TableMesh)

RotateMesh TableMesh2,0,90,180
PositionMesh TableMesh2,0,6,0

AddMesh TableMesh2,TableMesh
FreeEntity TableMesh2

HideEntity TableMesh

TableMeshPhys = LoadMesh("PressPapierPhys.b3d")
Desc = pxCreateCompoundDesc()
Sh = CompoundCreateAddHullShape(Desc,TableMeshPhys)
Sh = CompoundCreateAddHullShape(Desc,TableMeshPhys)

pxCompoundSetShapeRot(sh,0,90,180)
pxCompoundSetShapePos(sh, 0, 6, 0)


FreeEntity TableMeshPhys
Global TableBody = pxCreateCompound(Desc,1)
pxBodySetFlagCollision TableBody,0



Repeat

If KeyHit(57) Then CreatepxTable(0,10,0)

pxRenderPhysic(60,0)
UpdatepxTables()

RenderWorld()
Flip

Until KeyHit(1)
End

Type pxTable
	Field mesh
	Field body
End Type

Function UpdatepxTables()
	For pxT.pxTable = Each pxTable
		pxBodySetEntity pxT\mesh, pxT\body
	Next
End Function

Function CreatepxTable(x#,y#,z#)
	pxT.pxTable = New pxTable
	pxT\mesh = CopyEntity(TableMesh)
	pxT\body = pxCopyBody(TableBody)	
	pxBodySetPosition pxT\body,x+Rnd(-10,10),y,z+Rnd(-2,2)	
End Function

Function CompoundCreateAddHullShape%(Desc, mesh%)
    Local nsurf = CountSurfaces(mesh)
    Local nvert = 0
    For ns = 1 To nsurf
        Local surf = GetSurface(mesh,ns)
        nvert = nvert + CountVertices(surf)
    Next
         vbank = CreateBank(nvert*4*3)
    nv = 0
    For ns = 1 To nsurf
        surf = GetSurface(mesh,ns)
        nvv = CountVertices(surf)
        For nvc = 0 To nvv - 1
             PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
             PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
             PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
            nv = nv+1
        Next
    Next
    Local bbb%= pxCompoundAddHullShape(Desc,vbank, nvert)
    FreeBank vbank
    Return bbb
End Function